#include "StdAfx.h"
#include "FormMain.h"
#include "SetRect.h"
#include "SetProperty.h"

namespace Sample {

	System::Void formMain::formMain_Resize(System::Object^  sender, System::EventArgs^  e)
	{
		// eLXg{bNXNCAg̈ɍ킹B
		this->textDecodeResult->Width = this->ClientRectangle.Width;
		this->textDecodeResult->Height = this->ClientRectangle.Height - this->menuStrip1->Height;
	}

	System::Void formMain::textDecodeResult_DragEnter(System::Object^  sender, System::Windows::Forms::DragEventArgs^  e)
	{
		// t@Ĉ݃hbOhbv
		if (e->Data->GetDataPresent(DataFormats::FileDrop))
			e->Effect = DragDropEffects::Copy;
	}

	System::Void formMain::textDecodeResult_DragDrop(System::Object^  sender, System::Windows::Forms::DragEventArgs^  e)
	{
		// t@Chbv
	    DecodeFile(dynamic_cast<array<String^>^>(e->Data->GetData(DataFormats::FileDrop))[0]);
	}

	System::Void formMain::menuFileOpen_Click(System::Object^  sender, System::EventArgs^  e)
	{
		// [t@C]-[J]

		OpenFileDialog^ openFileDialog1 = gcnew OpenFileDialog;

		openFileDialog1->Filter = "sN` t@C (*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png)|*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png|" +
								  "rbg}bv t@C (*.bmp)|*.bmp|" +
								  "JPEG ` (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
								  "GIF ` (*.gif)|*.gif|" +
								  "TIFF ` (*.tif;*.tiff)|*.tif;*.tiff|" + 
								  "PNG ` (*.png)|*.png|" +
								  "ׂẴt@C (*.*)|*.*";
		openFileDialog1->FilterIndex = nFilterIndex;
		openFileDialog1->RestoreDirectory = true;

		// R_CAOɂt@CI
		if (openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK)
		{
			nFilterIndex = openFileDialog1->FilterIndex;
			DecodeFile(openFileDialog1->FileName);
		}
	}

	System::Void formMain::menuAppExit_Click(System::Object^  sender, System::EventArgs^  e)
	{
		//vOI
		Close();
	}

	System::Void formMain::menuSetDecodeRect_Click(System::Object^  sender, System::EventArgs^  e)
	{
        // fR[h͈͎w_CAO\
        formSetRect^ setRectDialog = gcnew formSetRect();

        setRectDialog->ShowDialog(); // [_\
	}

	System::Void formMain::menuSetDecodeProperty_Click(System::Object^  sender, System::EventArgs^  e)
	{
        // fR[hݒ_CAO\
        formSetProperty^ setPropertyDialog = gcnew formSetProperty();

        setPropertyDialog->ShowDialog(); // [_\
	}

	System::Void formMain::DecodeFile(String^ strFilePath)
	{
		// 摜t@CΏۂƂfR[h

		String^ strSeparator = "\r\n";
		array<String^>^ strLevel = { "L(7%)", "M(15%)", "Q(25%)", "H(30%)" };

		// vJ[\\
		System::Windows::Forms::Cursor::Current = System::Windows::Forms::Cursors::WaitCursor;

		// DLLt@NVɂfR[h
		int nResult;

		if (blnEnableSetRect)
		{
			// ͈͎w肠
			nResult = PsyQrDcd::DecodePictureFileRect(strFilePath, nRectLeft, nRectTop, nRectRight, nRectBottom);
		}
		else
		{    // ͈͎wȂ
			nResult = PsyQrDcd::DecodePictureFile(strFilePath);
		}

		// J[\
		System::Windows::Forms::Cursor::Current = System::Windows::Forms::Cursors::Default;

		String^ strResult = ""; // fR[hʕieLXg{bNX\pj

		if (nResult >= 1)
		{
			// fR[hI
			for (int i = 0; i < nResult; ++i)
			{
				strResult += strSeparator;

				String^ strWork;

				// V{^ԁAx
				strWork = String::Format("fR[h f[^ {0} [^:{1}, x:{2}", i + 1, PsyQrDcd::GetDecodeVersion(i), strLevel[PsyQrDcd::GetDecodeLevel(i)]);
				strResult += strWork;

				// V{A
				int nSeqNo = 0;
				Byte byCheckDigit = 0;

				int ncConcatenation = PsyQrDcd::GetConcatenationInfo(i, &nSeqNo, &byCheckDigit);

				if (ncConcatenation > 0)
				{
					strWork = String::Format(", A:{0}/{1}(CD:{2:X2}H)", nSeqNo + 1, ncConcatenation, byCheckDigit);
					strResult += strWork;
				}

				strResult += "]\r\n";

				strResult += strSeparator;

				// fR[hf[^
				IntPtr lpBuff = IntPtr::Zero;

				// mۂobt@ɃV{f[^擾ꍇ́Aȉ̂悤ɂĂB(1sƒu)
				// char szBuff[7090]; // 7089(QRR[hőeʃoCg) + 1(I['\0')
				// IntPtr lpBuff(szBuff);

				PsyQrDcd::GetDecodeData(i, &lpBuff);

				// }[VOɂ蕶擾
				strResult += Marshal::PtrToStringAnsi(lpBuff);

				strResult += "\r\n\r\n";

				// V{ʒu
				int* nPosition = new int[8];

				PsyQrDcd::GetSymbolePosition(i, nPosition);

				strWork = String::Format("V{ʒuF({0}, {1})-({2}, {3})-({4}, {5})-({6}, {7})",
										 nPosition[0], nPosition[1], nPosition[2], nPosition[3],
										 nPosition[4], nPosition[5], nPosition[6], nPosition[7]); 
				strResult += strWork;
				strResult += "\r\n\r\n";
			}

			// fR[hʕۑJ
			PsyQrDcd::FreeAllocateMemory();
		}
		else
		{
			switch (nResult)
			{
			case QRD_ERROR_SYMBLE_NOT_FOUND:
				strResult = "QRR[h V{ǂݎ܂łB";

				switch (PsyQrDcd::GetErrorLevel())
                {
                    case 1:
                        strResult += "\r\n";
                        strResult += "(ʒuop^[܂łB)";
		                break;                    

                    case 2:
                        strResult += "\r\n";
                        strResult += "(ʒuop^[V{Fł܂łB)";
		                break;

                    case 3:
                        strResult += "\r\n";
                        strResult += "(f[^̓ǂݎɎs܂B)";
		                break;                    

                    default:
		                break;                    
                }

                break;

			case QRD_ERROR_FILE_NOT_FOUND:
				strResult = "t@C܂łB";
				break;

			case QRD_ERROR_READ_FAULT:
				strResult = "t@CǂݍݒɃG[܂B";
				break;

			case QRD_ERROR_BAD_FORMAT:
				strResult = "ǂݎłȂt@CʂłB";
				break;

			case QRD_ERROR_SHARING_VIOLATION:
				strResult = "Lᔽɂt@Cǂݎ邱Ƃł܂łB";
				break;

			case QRD_ERROR_NOT_ENOUGH_MEMORY:
				strResult = "słB";
				break;

			default:
				break;
			}
		}

		textDecodeResult->Text = strResult;
	}
}
